#
# Utilities
#
# Copyright (c) 2001-2003 by Philipp "philiKON" von Weitershausen
#
# This software is distributed under the terms of the Mozilla Public
# License (MPL)
#

"""
$Id: util.py,v 1.3 2003/05/21 00:03:56 philipp Exp $
"""

def guess_meta_type(data):
    """
    Guess the meta type of 'data'
    """
    # This is very simple for now
    # If a token in the table is found, it is assummed that the corresponding
    # meta_type is correct
    
    #XXX missing images for now
    table = {
        '<dtml-':            'DTML Method',
        ' tal:':             'Page Template',
        ' Script (Python) ': 'Script (Python)',
        '<params>':          'Z SQL Method'
        }
    default_meta_type = "File"

    for chunk, meta_type in table.items():
        if data.find(chunk) >= 0:
            return meta_type
    return default_meta_type

def is_binary(file):
    """
    Check whether a file represented by file object 'file' contains
    binary data or text
    """
    chunk_size = 4*1024
    # read the file chunk-wise
    data = file.read(chunk_size)
    while data:
        for char in data:
            # binary files usually contain bytes < ASCII 7
            if char <= '\7':
                file.seek(0)
                return 1
        data = file.read(chunk_size)
    return 0

token_replacements = {
    '\\\\': '\\',
    '\\t': '\t',
    '\\r': '\r',
    '\\n': '\n',
    }

# stolen from apelib
def escape_string(s):
    s = s.replace('\\', '\\\\')
    s = s.replace('\n', '\\n')
    s = s.replace('\r', '\\r')
    return s.replace('\t', '\\t')

# stolen from apelib
def unescape_string(s):
    res = []
    pos = 0
    while 1:
        p = s.find('\\', pos)
        if p >= 0:
            res.append(s[pos:p])
            token = s[p:p+2]
            c = token_replacements.get(token)
            if c is not None:
                # known escape sequence
                res.append(c)
            else:
                # unknown sequence
                res.append(token)
            pos = p + 2
        else:
            res.append(s[pos:])
            break
    return ''.join(res)
